# NEC Technologies Interview Questions
#### Profile: Member of Technical Staff
* [Coding Round Questions](#coding)
* [Technical Interview Questions](#tech)
   * [Data Structures and Algorithms](#dsalg)
   * [DBMS](#dbms)
   * [Operating System](#os)
   * [Miscellaneous](#misc)
* [References](#ref)
____
<b name="coding">Coding round questions</b><br/>
- Display all numbers between 32-62 which ends with 5.
- Write a program that accepts a decimal number and outputs the binary representation of that number.
- Given ASCII values, output the string. 
- You are given an m x n 2D matrix. Rotate the image by 90 degrees (anti-clockwise).
- Write a program to convert infix to postfix.
- Write a program to print transpose of a given matrix.
- Given a 2D array, find the maximum sum subarray in it. 
- Given a binary search tree, write a function kthSmallest to find the kth smallest element in it.
- Given a text file, I want the words to be scanned from it, along with their occurrences, sort them in descending order, & display the top 10 words.
- Find the second largest number.
- Find whether two strings are anagram of each other.
- Find missing number unsorted contiguous array.
- Find Number of common Guests in all parties if user give the input in the following format.
The guests list for parties is in one line separated by Comma(,).
     ```
     
      Input: 122,444,2223,122,1111,122,2233,123,333,333,444,
        1111,122
      Output:
        2233:1
        2223:1
        333:2
        444:2
        1111:2
        122:4
        123:1
        
     ```    

        

----
<b name="tech">Technical Interview Questions</b>
<br/>
<i><u name="dsalg">Data Structures and Algorithms</u></i>
- Write a recursive function to print reverse of a Linked List.
- Write a program in C/C++ to sort an Array in O(n).
- WAP to reverse a linked list.
- Implement queue.
- What are the advantages of doubly linked list.
- Various types of Hashing-Linear, Quadratic and Mid-Square.
- Decimal to Binary program using recursion.
- Find the largest Number of Array using recursion.
- WAP to sort a Linked List.
- Program for converting Little to Big Endian.
- Find the center element of a linked list?
- Print left view of Binary Search Tree.
- Implement circular linked list.
- Write a program on pallindrome linked list and stack implementation using linked list.
- Program to remove duplicates from linked list.
- Program to detect if there is any loop in linked list.
- Write program for maximum of 4 numbers in good readable, optimized code.

<br/><br/>
<i><u name="dbms">DBMS</u></i>

- Database design using Normalization.
- What are DBMS, RDBMS and ORDBMS ?
- What is DDL, DML and DCL?
- What is clustered indexing?
- Transaction and normalisation.

<br/>
<br/>
<i><u name="os">Operating System</u></i>

- Define Semaphores, Fragmentation, Normalization?  
- Discuss about Deadlock, Cyclic wait.
- Paging and segmentation.
- What is thrashing?
- What is the difference between mutex and binary semaphore?
- Can you name some IPC(Inter-process communication) mechanism?

<br/>
<br/>
<i><u name="misc">Miscellaneous</u></i>

- How to implement a class in C?
- Difference between C and C++.
- What is template ?
- Elaborate upon the fact of inheritance in C structures.
- How can you make the same variable accessible to two C programs ?
- Define Synchronization, Desynchronization, Interim, Manipulation(Java).
- Name the technologies to store Sequential Files.
- Difference between exe and dll.
- Discussion about Volatile(in C).
- Difference between const, const pointer, const to pointer(in C).
- What is virtual function in C++? What is pure virtual function?
- What is dual core, cache m/m, throughput of processors.
- Abstract class and Interface in Java.
- What is difference between virtual and static class.
- Differentiate between Call by value, call by address, call by refrence.
- Implement operator overloading in C++?  

  
## Feel free to show your love :heart: by putting a star :star: on this project :v: .
