# PayPal Interview Questions
* [Coding Round Questions](#coding)
* [Technical Interview Questions](#tech)
   * [Data Structures and Algorithms](#dsalg)
   * [DBMS](#dbms)
   * [Operating System](#os)
   * [Miscellaneous](#misc)
* [References](#ref)
____
<b name="coding">Coding round questions</b><br/>
- An array A consists of n cells, n ranges from 0 to n. Each cell consists of n elements whose value ranges from 1 to n. Create an array B such that B[i] must be as small as B[j] for all values of j that appears in A.

- Find the least number of coins required that can make any desired amount. The coins can only be pennies(1), nickels(5), dimes(10) and quarters(25).
- Given an integer array of size n, find the maximum of the minimum’s of every window size in the array. Note that window size varies from 1 to n.

----
<b name="tech">Technical Interview Questions</b>
<br/>
<i><u name="dsalg">Data Structures and Algorithms</u></i>
- Implement a singleton class.
- Explain binary tree and binary search tree.
- Implement stack using classes in C++.
- Longest palindromic subsequence in string.
- Detect loop in a linked list and remove it.
- Select first 3 lines of the file. Select the longest line and count the number of words in that line.
- Given an array of strings, find the shortest length palindrome.
- Find the shortest cost path in a 3x3 matrix starting from top-left to bottom-right cell.
- Design a sudoku solver.
<br/>

<i><u name="dbms">DBMS</u></i>
- Different types of joins.

<i><u name="os">Operating System</u></i>
- Explain deadlock.
<br>

<i><u name="misc">Miscellaneous</u></i>
- What is dangling pointer?
- What happens when you type a URL in web browser?
- What are virtual functions and virtual destructors ?
- Diamond structure problem.
- What happens when you create an object using a base class pointer?
- Why Java uses interface ?
- Difference between array and ArrayList. Advantage of array.
- Differnce between preincrement and postincrement.
- Distinguish between Hashtable and HashMap.
- How is HashMap implemented in Java?
-  Draw an entity relationship diagram for a student enrolment system.
-  Draw an entity relationship diagram for a airport management system.
- Does encapsulation really exist in OOPS or is it just conceptual?
